//每次询问,给出l,r,k,询问[l,r]中所有长度>=k的连续子区间的lca深度的最大值
//因为每加入一个节点,lca的深度只会不变或变少,因此选长度>k的区间一定不优,仅需考虑所有长度=k的区间
//考虑选了节点i后怎么选最优:肯定是从i-1,i+1中选一个与i的lca更深的点 

#include<iostream>
using namespace std;

struct edge{
	int to,nxt;
}; 

const int MAXN=5e3+5;
const int MAXM=5e5+5;
int n,q,mx,lg[MAXM],dep[MAXM],fa[MAXM][19],st[MAXM][19];
int tot,head[MAXM];
edge e[MAXM<<1];

void add(int u,int v){
	e[++tot]={v,head[u]};
	head[u]=tot;
	return;
}

void dfs(int u,int f){
	dep[u]=dep[f]+1;
	fa[u][0]=f;
	st[u][0]=u;
	for(int i=head[u];i;i=e[i].nxt){
		int v=e[i].to;
		if(v==f) continue;
		dfs(v,u);
	}
}

int lca(int u,int v){
	if(dep[u]<dep[v]) swap(u,v);//u更深 
	for(int i=mx;i>=0;i--){
		if(dep[fa[u][i]]>=dep[v])
			u=fa[u][i];
	}
	if(u==v) return u;
	for(int i=mx;i>=0;i--){
		if(fa[u][i]!=fa[v][i]){
			u=fa[u][i];
			v=fa[v][i];
		}
	}
	return fa[u][0];
}

void init(){
	lg[0]=lg[1]=0;
	for(int i=2;i<=n;i++) lg[i]=lg[i>>1]+1;
	mx=lg[n];
	for(int j=1;j<=mx;j++){
		for(int i=1;i<=n;i++){
			fa[i][j]=fa[fa[i][j-1]][j-1];
		}
	}
	for(int j=1;j<=mx;j++){
		for(int i=1;i<=n;i++){
			if((i+(1<<j)-1)>n) break;
			st[i][j]=lca(st[i][j-1],st[i+(1<<(j-1))][j-1]);
		}
	}
	return;
}

int main(){
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	std::ios::sync_with_stdio(false);
	cin.tie(0);
	cin>>n;
	for(int i=1;i<n;i++){
		int u,v;
		cin>>u>>v;
		add(u,v);
		add(v,u);
	}
	dfs(1,0);
	init();
	cin>>q;
	while(q--){
		int l,r,k,ans=0;
		cin>>l>>r>>k;
		for(int i=l;i<=r-k+1;i++){
			int j=i+k-1;
			ans=max(ans,dep[lca(st[i][lg[k]],st[j-(1<<lg[k])+1][lg[k]])]);
		}
		cout<<ans<<'\n';
	}
	return 0;
}

//能过n,q<=5000 && B
//11:50  228pts 
